config/routes.rb
Rails.application.routes.draw do
  ####### BEGIN: Staff ########
  namespace :staffs do
    get 'sign_in', to: 'sessions#new'
    resource  :sessions, only: %i[create destroy]
    resources :dashboard, only: %i[index]
    resource  :account, only: %i[show update], controller: :account do
      patch 'update_password'
      patch 'update_avatar'
    end

    root 'dashboard#index'
  end
end

app/models/staff.rb
# frozen_string_literal: true

class Staff < ApplicationRecord
  has_secure_password

  ###### BEGIN: Inclusion ########
  include LogicalDelete
  include FullNameSearchable

  ###### BEGIN: Enumerables ########
  enum role: { standard: 0, manager: 1, super_administrator: 9 }

  ###### Storables ########
  has_one_attached :avatar

  ###### BEGIN: Validations ########
  # Validation: Core informations
  validates_presence_of :email, :role, :first_name, :last_name
  validates_format_of :email, with: Settings.regex.email, if: -> { email.present? }
  validates :role, inclusion: { in: roles.keys }
  validates_length_of :email, :first_name, :last_name, :reset_password_token,
                      :phone_number, :address, maximum: 255
  validates :avatar, storage_file: {
    size_maximum: 300.kilobytes,
    content_type: ['image/png', 'image/jpg', 'image/jpeg']
  }
  # Validation: Addition informations
  validates_format_of :phone_number, with: Settings.regex.phone_number, if: -> { phone_number.present? }
  validates_length_of :address, maximum: 255
  validates :birthdate, date_time_range: {
    greater_than_or_equal_to: proc { |_| Date.current - Settings.datetime.maximum_birthdate_gap.years },
    less_than_or_equal_to: proc { |_| Date.current + Settings.datetime.minimum_birthdate_gap.years }
  }, if: -> { birthdate.present? }

  ###### BEGIN: Getters ########
  def names(before_changed: false)
    return { first: first_name, last: last_name } unless before_changed

    { first: first_name_was, last: last_name_was }
  end

  def avatar_image
    @avatar_image ||= if avatar.attached?
                        avatar
                      else
                        Settings.image.default_avatar
                      end
  end
end

app/controllers/staffs/account_controller.rb
# frozen_string_literal: true

module Staffs
  class AccountController < BaseController
    def show; end

    def update
      current_staff.update! updating_params
      notify :success, I18n.t('notifications.account.updated_successfully'), now: true
    end

    def update_password
      service = ::Account::ChangingPasswordService.new(updating_password_params)
      service.of_record(current_staff).change!
      notify :success, t('notifications.account.updated_password_successfully'), now: true
      @updated = true
    ensure
      current_staff.errors.merge! service.errors
    end

    def update_avatar
      service = Account::UpdatingAvatarService.new(current_staff, updating_avatar_params)
      service.execute!
      notify :success, t('notifications.account.updated_avatar_successfully'), now: true
      @updated = true
    ensure
      @staff = service.record
    end

    private

    def updating_params
      params.require(:staff)
            .permit(:first_name, :last_name, :birthdate, :phone_number, :address)
    end

    def updating_password_params
      params.permit(:old_password, :password, :password_confirmation)
    end

    def updating_avatar_params
      params.permit(:avatar, :offset_x, :offset_y, :width, :height)
    end
  end
end

app/controllers/staffs/base_controller.rb
# frozen_string_literal: true

class Staffs::BaseController < ApplicationController
  include Auth::StaffsHelper
  include Common::NotificationsHelper::Backend

  before_action :authenticate_staff!, except: %i[new]

  layout 'staffs'
end

app/controllers/staffs/dashboard_controller.rb
# frozen_string_literal: true

module Staffs
  class DashboardController < BaseController
    def index; end
  end
end

app/controllers/staffs/sessions_controller.rb
# frozen_string_literal: true

module Staffs
  class SessionsController < BaseController
    skip_before_action :authenticate_staff!, only: %i[new create]

    layout 'authentication'

    def new
      return redirect_to(staffs_root_path) if staff_signed_in?
    end

    def create
      (service = ::Staffs::Auth::SigningInService.new signing_in_params).verify!
      notify :success, I18n.t('notifications.auth.you_have_signed_in_successfully')
      warden.set_user service.staff, scope: :staff
    end

    def destroy
      warden.logout(:staff)
      notify :success, I18n.t('notifications.auth.you_have_signed_out_successfully')
      redirect_to staffs_sign_in_path
    end

    private

    def signing_in_params
      params.permit :email, :password
    end
  end
end

app/helpers/staffs/account_helper.rb
# frozen_string_literal: true

module Staffs::AccountHelper
end

app/helpers/staffs/base_helper.rb
# frozen_string_literal: true

module Staffs::BaseHelper
  include Pagy::Frontend

  include Common::HumansHelper
  include Common::TextsHelper
  include Common::TitlesHelper
  include Common::ParamsHelper
  include Common::RecordsHelper
  include Common::LanguagesHelper
  include Common::PaginationsHelper
  include Common::NotificationsHelper::Frontend

  # BEGIN: Layouts
  def breadcrumbs(**items)
    content_for :breadcrumbs, render('layouts/staffs/breadcrumb', items: items)
  end

  def navigation_item_name(content)
    return I18n.t('navigations.undefined') if content.blank?

    I18n.t "navigations.staff.#{content}", default: content.to_s
  end
end

app/helpers/staffs/dashboard_helper.rb
# frozen_string_literal: true

module Staffs::DashboardHelper
end

app/helpers/staffs/sessions_helper.rb
# frozen_string_literal: true

module Staffs::SessionsHelper
end

app/views/layouts/staffs/_breadcrumb.html.slim
nav aria-label='breadcrumb'
  ol.breadcrumb.bg-transparent.p-0.mt-1.mb-0
    li.breadcrumb-item
      a href=staffs_root_path
        = t('navigations.home')

    - items.each do |name, path|
      li.breadcrumb-item
        = link_to path do
          = navigation_item_name(name)

app/views/layouts/staffs/_navbar.html.slim
a.sidebar-toggle.d-flex
  i.hamburger.align-self-center

.navbar-collapse.collapse
  ul.navbar-nav.navbar-align
    / BEGIN: User section
    li.nav-item.dropdown.user_section
      a.nav-link.dropdown-toggle.d-sm-inline-block data-bs-toggle='dropdown' href='#'
        span.js-navbar-staff__fullname.user__name.text-dark.ms-2 = full_name(current_staff.names)

      .dropdown-menu.dropdown-menu-right
        a.dropdown-item href=staffs_account_path
          i.fa.fa-user.me-2
          = t('labels.staff.setting_account')
        .dropdown-divider

        = link_to staffs_sessions_path,
          method: :delete,
          class: 'dropdown-item',
          data: { confirm: t('confirmations.auth.sign_out') } do
          i.fa.fa-sign-out-alt.me-1
          = t('actions.auth.sign_out')

app/views/layouts/staffs/_sidebar.html.slim
.sidebar-content
  a.sidebar-brand href=staffs_root_path
    span.align-middle SDoc
    / = image_pack_tag 'media/assets/images/logo.png', class: 'sidebar__logo'

  ul.sidebar-nav.pb-3
    / Item: Dashboard
    li.sidebar-item class=('active' if params[:controller] == 'staffs/dashboard')
      a.sidebar-link href=staffs_root_path
        i.align-middle.fas.fa-tachometer-alt.fa-fw
        span.align-middle = t('navigations.staff.dashboard')